#!/bin/bash

usbdir=/mnt/usb
usbdevice=/dev/sdb1
bldir=/mnt/bl
bldevice=/dev/sdc

# Redirect output to firmware log
# exec 1<&-
# exec 2<&-
# exec 1<>/mnt/log/firmware.log
# exec 2>&1

if test -f ${usbdir}/nomount;
then
	echo "Installing from premounted directory..."
elif test -e ${usbdevice};
then
	mkdir -p ${usbdir}
	sleep 1
	if mount ${usbdevice} ${usbdir};
	then
		echo "Source mount successful."
	else
		exit 1
	fi
else
	exit 2
fi

if test -f ${bldir}/nomount;
then
	echo "Installing to premounted directory..."
else
	while [ ! -e ${bldevice} ]; do
		echo "Waiting for ${bldevice}..."
		sleep 2
	done
	mkdir -p ${bldir}
	if mount ${bldevice} ${bldir};
	then
		echo "Target mount successful."
	else
		exit 1
	fi
fi

echo "Scanning for firmware update from source..."
cd ${usbdir}
uf2file=`ls -t *.uf2 | head -n1`
if [ -f "${uf2file}" ]; then
	echo "Copying ${uf2file} to ${bldir}..."
	cp -p ${uf2file} ${bldir}
	cpresult=$?
	echo "Copy command rc=${cpresult}, unmounting."
	umount ${bldir}
	if [ $cpresult -eq 0 ]; then
		exit_code=0
	else
		exit_code=4
	fi
else
	exit_code=3
fi
echo "Firmware update check complete."

umount ${usbdir}
umount ${bldir}

exit ${exit_code}
